using cuqmbr.TravelGuide.Application.Common.Models;
using cuqmbr.TravelGuide.Domain.Enums;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Addresses.Queries.GetAddressesPage;

public record GetAddressesPageQuery : IRequest<PaginatedList<AddressDto>>
{
    public int PageNumber { get; set; } = 1;

    public int PageSize { get; set; } = 10;

    public string Search { get; set; } = String.Empty;

    public string Sort { get; set; } = String.Empty;

    public Guid? CountryGuid { get; set; }

    public Guid? RegionGuid { get; set; }

    public Guid? CityGuid { get; set; }

    public double? LongitudeGreaterOrEqualThan { get; set; }

    public double? LongitudeLessOrEqualThan { get; set; }

    public double? LatitudeGreaterOrEqualThan { get; set; }

    public double? LatitudeLessOrEqualThan { get; set; }

    public VehicleType? VehicleType { get; set; }
}
