using MediatR.Behaviors.Authorization;

namespace cuqmbr.TravelGuide.Application.Common.Authorization;

public class MustBeAuthenticatedRequirement : IAuthorizationRequirement
{
    public required bool IsAuthenticated { get; init; } = default!;

    class MustBeAuthenticatedRequirementHandler :
        IAuthorizationHandler<MustBeAuthenticatedRequirement>
    {
        public Task<AuthorizationResult> Handle(
            MustBeAuthenticatedRequirement request,
            CancellationToken cancellationToken)
        {
            if (!request.IsAuthenticated)
            {
                return Task.FromResult(AuthorizationResult.Fail());
            }

            return Task.FromResult(AuthorizationResult.Succeed());
        }
    }
}
