using cuqmbr.TravelGuide.Application.Common.Mappings;
using cuqmbr.TravelGuide.Domain.Entities;

namespace cuqmbr.TravelGuide.Application.Companies;

public sealed class CompanyAccountDto : IMapFrom<Account>
{
    public Guid Uuid { get; set; }

    public string Username { get; set; }

    public string Email { get; set; }

    public void Mapping(MappingProfile profile)
    {
        profile.CreateMap<Account, CompanyAccountDto>()
            .ForMember(
                d => d.Uuid,
                opt => opt.MapFrom(s => s.Guid));
    }
}
