using MediatR;
using cuqmbr.TravelGuide.Domain.Enums;
using cuqmbr.TravelGuide.Application.Employees.Models;

namespace cuqmbr.TravelGuide.Application.Employees.Commands.UpdateEmployee;

public record UpdateEmployeeCommand : IRequest<EmployeeDto>
{
    public Guid Guid { get; set; }

    public string FirstName { get; set; }

    public string LastName { get; set; }

    public string Patronymic { get; set; }

    public Sex Sex { get; set; }

    public DateOnly BirthDate { get; set; }


    public Guid CompanyGuid { get; set; }

    public ICollection<EmployeeDocumentModel> Documents { get; set; }
}
