using cuqmbr.TravelGuide.Application.Common.Models;
using cuqmbr.TravelGuide.Domain.Enums;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Identity.Accounts.Queries.GetAccountsPage;

public record GetAccountsPageQuery : IRequest<PaginatedList<AccountDto>>
{
    public int PageNumber { get; set; } = 1;

    public int PageSize { get; set; } = 10;

    public string Search { get; set; } = String.Empty;

    public string Sort { get; set; } = String.Empty;

    public ICollection<IdentityRole>? Roles { get; set; }
}
