using cuqmbr.TravelGuide.Application.Common.Mappings;
using cuqmbr.TravelGuide.Domain.Entities;

namespace cuqmbr.TravelGuide.Application.Routes;

public sealed class RouteDto : IMapFrom<Route>
{
    public Guid Uuid { get; set; }

    public string Name { get; set; }

    public string VehicleType { get; set; }

    public ICollection<RouteAddressDto> Addresses { get; set; }

    public void Mapping(MappingProfile profile)
    {
        profile.CreateMap<Route, RouteDto>()
            .ForMember(
                d => d.Uuid,
                opt => opt.MapFrom(s => s.Guid))
            .ForMember(
                d => d.VehicleType,
                opt => opt.MapFrom(s => s.VehicleType.Name))
            .ForMember(
                d => d.Addresses,
                opt => opt.MapFrom(s => s.RouteAddresses));
    }
}
