using FluentValidation;
using Microsoft.Extensions.Localization;

namespace cuqmbr.TravelGuide.Application.TicketGroups
    .Commands.RemoveOldReservedTicketGroups;

public class RemoveOldReservedTicketGroupsCommandValidator :
    AbstractValidator<RemoveOldReservedTicketGroupsCommand>
{
    public RemoveOldReservedTicketGroupsCommandValidator(
        IStringLocalizer localizer)
    {
        RuleFor(v => v.ReservedFor)
            .GreaterThanOrEqualTo(TimeSpan.Zero)
            .WithMessage(
                String.Format(
                    localizer["FluentValidation.GreaterThanOrEqualTo"],
                    TimeSpan.Zero));
    }
}
