using cuqmbr.TravelGuide.Domain.Enums;
using MediatR;

namespace cuqmbr.TravelGuide.Application
    .VehicleEnrollmentSearch.Queries.SearchAll;

public record SearchAllQuery :
    IRequest<IEnumerable<VehicleEnrollmentSearchDto>>
{
    public Guid DepartureAddressGuid { get; set; }

    public Guid ArrivalAddressGuid { get; set; }

    public DateOnly DepartureDate { get; set; }

    public HashSet<VehicleType> VehicleTypes { get; set; }

    public string Sort { get; set; } = String.Empty;

    public TimeSpan? TravelTimeGreaterThanOrEqualTo { get; set; }

    public TimeSpan? TravelTimeLessThanOrEqualTo { get; set; }

    public decimal? CostGreaterThanOrEqualTo { get; set; }

    public decimal? CostLessThanOrEqualTo { get; set; }

    public short? NumberOfTransfersGreaterThanOrEqualTo { get; set; }

    public short? NumberOfTransfersLessThanOrEqualTo { get; set; }

    public DateTimeOffset? DepartureTimeGreaterThanOrEqualTo { get; set; }

    public DateTimeOffset? DepartureTimeLessThanOrEqualTo { get; set; }

    public DateTimeOffset? ArrivalTimeGreaterThanOrEqualTo { get; set; }

    public DateTimeOffset? ArrivalTimeLessThanOrEqualTo { get; set; }
}
