using cuqmbr.TravelGuide.Application.Common.Mappings;
using cuqmbr.TravelGuide.Domain.Entities;

namespace cuqmbr.TravelGuide.Application.VehicleEnrollmentSearch;

public sealed class VehicleEnrollmentSearchCompanyDto : IMapFrom<Company>
{
    public string Uuid { get; set; }

    public string Name { get; set; }

    public string LegalAddress { get; set; }

    public string ContactEmail { get; set; }

    public string ContactPhoneNumber { get; set; }

    public void Mapping(MappingProfile profile)
    {
        profile.CreateMap<Company, VehicleEnrollmentSearchCompanyDto>()
            .ForMember(
                d => d.Uuid,
                opt => opt.MapFrom(s => s.Guid));
    }
}
