using cuqmbr.TravelGuide.Application.Common.Services;
using System.Globalization;

namespace cuqmbr.TravelGuide.HttpApi.Middlewares;

public class ThreadCultureSetterMiddleware : IMiddleware
{
    private readonly SessionCultureService _cultureService;

    public ThreadCultureSetterMiddleware(SessionCultureService cultureService)
    {
        _cultureService = cultureService;
    }

    public async Task InvokeAsync(HttpContext context, RequestDelegate next)
    {
        CultureInfo.DefaultThreadCurrentCulture = _cultureService.Culture;
        CultureInfo.DefaultThreadCurrentUICulture = _cultureService.Culture;

        await next(context);
    }
}
