namespace cuqmbr.TravelGuide.Infrastructure;

public sealed class ConfigurationOptions
{
    public static string SectionName { get; } = "";

    public PaymentProcessingConfigurationOptions PaymentProcessing { get; set; } = new();

    public EmailConfigurationOptions Email { get; set; } = new();
}

public sealed class PaymentProcessingConfigurationOptions
{
    public string CallbackAddressBase { get; set; }

    public string ResultAddressBase { get; set; }

    public LiqPayConfigurationOptions LiqPay { get; set; } = new();
}

public sealed class LiqPayConfigurationOptions
{
    public string PublicKey { get; set; }

    public string PrivateKey { get; set; }
}

public sealed class EmailConfigurationOptions
{
    public SmtpConfigurationOptions Smtp { get; set; } = new();
}

public sealed class SmtpConfigurationOptions
{
    public string Host { get; set; }

    public ushort Port { get; set; }

    public bool UseTls { get; set; }

    public string Username { get; set; }

    public string Password { get; set; }

    public string SenderAddress { get; set; }

    public string SenderName { get; set; }
}
