using cuqmbr.TravelGuide.Domain.Entities;
using cuqmbr.TravelGuide.Domain.Enums;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace cuqmbr.TravelGuide.Persistence.PostgreSql.Configurations;

public class RoleConfiguration : BaseConfiguration<Role>
{
    public override void Configure(EntityTypeBuilder<Role> builder)
    {
        builder
            .Property(r => r.Value)
            .HasColumnName("name")
            .IsRequired(true);

        builder
            .ToTable(
                "roles",
                r => r.HasCheckConstraint(
                    "ck_" +
                    $"{builder.Metadata.GetTableName()}_" +
                    $"{builder.Property(r => r.Value)
                        .Metadata.GetColumnName()}",
                    $"{builder.Property(r => r.Value)
                        .Metadata.GetColumnName()} IN ('{String
                        .Join("', '", IdentityRole.Enumerations
                            .Values.Select(v => v.Name))}')"));

        base.Configure(builder);
    }
}
