﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    /// <inheritdoc />
    public partial class Add_Bus_Aircraft_Train_with_basic_properties : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateSequence(
                name: "vehicles_id_sequence",
                schema: "application");

            migrationBuilder.CreateTable(
                name: "vehicles",
                schema: "application",
                columns: table => new
                {
                    id = table.Column<long>(type: "bigint", nullable: false, defaultValueSql: "nextval('application.vehicles_id_sequence')"),
                    vehicle_type = table.Column<string>(type: "varchar(16)", nullable: false),
                    number = table.Column<string>(type: "varchar(32)", nullable: true),
                    model = table.Column<string>(type: "varchar(64)", nullable: true),
                    capacity = table.Column<short>(type: "smallint", nullable: true),
                    uuid = table.Column<Guid>(type: "uuid", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("pk_vehicles", x => x.id);
                    table.UniqueConstraint("altk_vehicles_uuid", x => x.uuid);
                    table.CheckConstraint("ck_vehicles_vehicle_type", "vehicle_type IN ('bus', 'train', 'aircraft')");
                });
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "vehicles",
                schema: "application");

            migrationBuilder.DropSequence(
                name: "vehicles_id_sequence",
                schema: "application");
        }
    }
}
