﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    /// <inheritdoc />
    public partial class Add_Vehicle_Enrollment_Employee : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateSequence(
                name: "vehicle_enrollment_employees_id_sequence",
                schema: "application");

            migrationBuilder.CreateTable(
                name: "vehicle_enrollment_employees",
                schema: "application",
                columns: table => new
                {
                    id = table.Column<long>(type: "bigint", nullable: false, defaultValueSql: "nextval('application.vehicle_enrollment_employees_id_sequence')"),
                    employee_id = table.Column<long>(type: "bigint", nullable: false),
                    vehicle_enrollment_id = table.Column<long>(type: "bigint", nullable: false),
                    uuid = table.Column<Guid>(type: "uuid", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("pk_vehicle_enrollment_employees", x => x.id);
                    table.UniqueConstraint("altk_vehicle_enrollment_employees_uuid", x => x.uuid);
                    table.ForeignKey(
                        name: "fk_vehicle_enrollment_employees_employee_id",
                        column: x => x.employee_id,
                        principalSchema: "application",
                        principalTable: "employees",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "fk_vehicle_enrollment_employees_vehicle_enrollment_id",
                        column: x => x.vehicle_enrollment_id,
                        principalSchema: "application",
                        principalTable: "vehicle_enrollments",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "ix_vehicle_enrollment_employees_employee_id",
                schema: "application",
                table: "vehicle_enrollment_employees",
                column: "employee_id");

            migrationBuilder.CreateIndex(
                name: "ix_vehicle_enrollment_employees_vehicle_enrollment_id",
                schema: "application",
                table: "vehicle_enrollment_employees",
                column: "vehicle_enrollment_id");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "vehicle_enrollment_employees",
                schema: "application");

            migrationBuilder.DropSequence(
                name: "vehicle_enrollment_employees_id_sequence",
                schema: "application");
        }
    }
}
