﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    /// <inheritdoc />
    public partial class Add_navigation_from_Company_to_Account : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<long>(
                name: "account_id",
                schema: "application",
                table: "companies",
                type: "bigint",
                nullable: false,
                defaultValue: 0L);

            migrationBuilder.CreateIndex(
                name: "ix_companies_account_id",
                schema: "application",
                table: "companies",
                column: "account_id",
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "fk_companies_account_id",
                schema: "application",
                table: "companies",
                column: "account_id",
                principalSchema: "application",
                principalTable: "accounts",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "fk_companies_account_id",
                schema: "application",
                table: "companies");

            migrationBuilder.DropIndex(
                name: "ix_companies_account_id",
                schema: "application",
                table: "companies");

            migrationBuilder.DropColumn(
                name: "account_id",
                schema: "application",
                table: "companies");
        }
    }
}
